-----------------------------------------------------------------------------------------------
-- Client Lua Script for TellMeMore
-- Copyright (c) NCsoft. All rights reserved
-----------------------------------------------------------------------------------------------
 
require "Window"
require "Unit"
require "ICComm"
require "ICCommLib"
require "GameLib"
require "HousingLib"
require "CombatFloater"
 
-----------------------------------------------------------------------------------------------
-- TellMeMore Module Definition
-----------------------------------------------------------------------------------------------
local TellMeMore = {} 
 
-----------------------------------------------------------------------------------------------
-- Constants
-----------------------------------------------------------------------------------------------
-- e.g. local kiExampleVariableMax = 999
 
-----------------------------------------------------------------------------------------------
-- Initialization
-----------------------------------------------------------------------------------------------
function TellMeMore:new(o)
    o = o or {}
    setmetatable(o, self)
    self.__index = self 
	self.version = 1.1
	self.hasVersionChanged = false
	self.selectedGridElement = nil
	self.activeTrait = nil
	self.selectedText = nil
	self.tSavedData = nil
    -- initialize variables here
	self.eyeTypes = {
	"N/A",
	"Default/Normal",
	"Heterochromatic",
	"Blind - Left Eye",
	"Blind - Right Eye",
	"Blind - Both Eyes",
	"Missing - Left",
	"Missing - Right",
	"Missing - Both",
	"Slightly Scarred",
	"Other"
	}
	
	self.bodyTypes = {
	"N/A",
	"Average",
	"Buff",
	"Scrawny",
	"Chubby",
	"Petite",
	"Husky",
	"Stocky",
	"Sickly",
	"Overweight",
	"Athletic",
	"Sinewy",
	"Fluffy",
	"Lithe",
	"Other",
	"Topheavy",
	"Wide-Hipped"
	}
		
	self.raceTypes = {
	"N/A",
	"Aurin",
	"Cassian",
	"Chua",
	"Draken",
	"Granok",
	"Human",
	"Mechari",
	"Mordesh",
	"Highborn",
	"Lowborn",
	"Mixed",
	"Other (Ask)"
	}	
	
	self.genderTypes = {
	"N/A",
	"Female",
	"Male",
	"Androgynous",
	"Bigender",
	"Genderless",
	"Genderfluid",
	"Trans - MtF",
	"Trans - FtM",
	"Other (Ask)"
	}
	
	self.tattooTypes = {
	"N/A",
	"None",
	"Many - All Over",
	"Face",
	"Left Arm",
	"Right Arm",
	"Lower Back",
	"Back of Neck",
	"Forehead",
	"Cheek",
	"Left Hand",
	"Right Hand",
	"Both Hands",
	"Left Ankle",
	"Right Ankle",
	"Both Ankles",
	"Right Foot",
	"Left Foot",
	"Both Feet",
	"Upper Back",
	"Back",
	"Left Shoulder",
	"Right Shoulder",
	"Both Shoulders",
	"Other (Ask)"
	}
	
	self.hairStreaks = {
	"N/A",
	"White Streaks",
	"Black Streaks",
	"Red Streaks",
	"Pink Streaks",
	"Yellow Streaks",
	"Green Streaks",
	"Purple Streaks",
	"Orange Streaks",
	"Grey Streaks",
	"Blue Streaks",
	"Rainbow Streaks",
	"Other (Ask)"
	}
	
	self.hairFeatures = {
	"N/A",
	"Very Curly",
	"Gelled",
	"Styled",
	"Messy",
	"Unclean",
	"Well Kept",
	"Leafy",
	"Ragged",
	"Braided w/ Flowers",
	"Braided",
	"Static-Charged",
	"Dull",
	"Glossy",
	"Lustrous",
	"Neatly Combed",
	"Full",
	"Untamed",
	"Thinning",
	"Other (Ask)"
	}
	
	self.ageTypes = {
		"N/A",
		"Child",
		"Teenager",
		"Young Adult",
		"Adult",
		"Middle-Aged",
		"Elder",
		"Other (Ask)"
	}
	
	self.scarTypes = {
		"N/A",
		"No Scars",
		"Very Scarred",
		"Scarred Left Eye",
		"Scarred Right Eye",
		"Scarred Face",
		"Scarred Mouth",
		"Scarred Left Arm",
		"Scarred Right Arm",
		"Scarred Arms",
		"Scarred Chest",
		"Scarred Back",
		"Scarred Left Leg",
		"Scarred Right Leg",
		"Scarred Legs",
		"Other (Ask)"
		
	}
	
	self.talentTypes = {
		"N/A",
		"Fire Magic",
		"Water Magic",
		"Earth Magic",
		"Air Magic",
		"Logic Magic",
		"Life Magic",
		"Technomancer",
		"Nature-Speaker",
		"Engineering",
		"Excellent Hearing",
		"Excellent Sight",
		"Excellent Smell",
		"Heightened Senses",
		"Marksmanship",
		"Hunting",
		"Combat/Battle",
		"Cooking",
		"Brewing",
		"Hacking",
		"Tea-Making",
		"Jack of all trades",
		"Weave Using",
		"Piloting",
		"Healing/Medicine",
		"Alchemy",
		"Diplomacy",
		"Storytelling",
		"Military Strategy",
		"Racing",
		"Voodoo",
		"Comforting",
		"Other (Ask)"
	}
	
	self.disabilityTypes= {
		"N/A",
		"Blind",
		"Deaf",
		"Limp",
		"Lisp",
		"Illiterate",
		"Missing Left Arm",
		"Missing Right Arm",
		"Missing Both Arms",
		"Missing Left Leg",
		"Missing Right Leg",
		"Missing Both Legs",
		"Prosthetic Left Arm",
		"Prosthetic Right Arm",
		"Prosthetic Arms",
		"Prosthetic Left Eye",
		"Prosthetic Right Eye",
		"Prosthetic Eyes",
		"Prosthetic Left Ear",
		"Prosthetic Right Ear",
		"Prosthetic Ears",
		"Prosthetic Left Leg",
		"Prosthetic Right Leg",
		"Prosthetic Legs",
		"Physical Illness",
		"Mental Illness",
		"Anemic",
		"Other (Ask)"
	}
	self.relationshipList = {
		"N/A",
		"Married",
		"In a Relationship",
		"Open Relationship",
		"Single - Looking",
		"Single - Not Looking",
		"Polygamic",
		"Widowed",
		"Not Looking",
		"Other (Ask)",
		"Single"
	}
	
	self.sexualityList = {
		"N/A",
		"Heterosexual",
		"Homosexual",
		"Asexual - Romantic",
		"Asexual - Aromantic",
		"Bisexual",
		"Demisexual",
		"Pansexual",
		"Other (Ask)"
	}
	
	self.heightList = {
		"N/A",
		"Average",
		"Tall",
		"Short",
		"Very Tall",
		"Very Short",
		"Tiny",
		"Imposing",
		"Other (Ask)"
	}
	
	self.facialHairList = {
		"N/A",
		"Clean-Shaven",
		"Smooth-Shaven",
		"Trimmed Beard",
		"Untrimmed Beard",
		"Goatee",
		"Moustache",
		"Sideburns",
		"Mutton-Chops",
		"Stubble",
		"Five o'clock Shadow",
		"Other (Ask)"
	}
	
	self.DataStructure = {
		"Age",
		"Race",
		"Gender",
		"Sexuality",
		"Relationship",
		"Eye Feature",
		"Body Build",
		"Hair Streaks",
		"Hair Features",
		"Tattoos",
		"Scars",
		"Talent 1",
		"Talent 2",
		"Talent 3",
		"Disability 1",
		"Disability 2",
		"Disability 3",
		"Height",
		"Facial Hair"
	}
	
	
	
	self.DataToSend = {
		Age = 1,
		Race = 1,
		Gender = 1,
		Sexuality = 1,
		Relationship = 1,
		["Eye Feature"] = 1,
		["Body Build"] = 1,
		["Hair Streaks"] = 1,
		["Hair Features"] = 1,
		Tattoos = 1,
		Scars = 1,
		["Talent 1"] = 1,
		["Talent 2"] = 1,
		["Talent 3"] = 1,
		["Disability 1"] = 1,
		["Disability 2"] = 1,
		["Disability 3"] = 1,
		["Height"] = 1,
		["Facial Hair"] = 1
		
	}	
	
	self.DataRecieved = {}
	
	self.DataArrays = {
		["Age"] = self.ageTypes,
		["Eye Feature"] = self.eyeTypes,
		["Body Build"] = self.bodyTypes,
		Race = self.raceTypes,
		Gender = self.genderTypes,
		Sexuality = self.sexualityList,
		Relationship = self.relationshipList,
		["Hair Streaks"] = self.hairStreaks,
		["Hair Features"] = self.hairFeatures,
		Tattoos = self.tattooTypes,
		Scars = self.scarTypes,
		["Talent 1"] = self.talentTypes,
		["Talent 2"] = self.talentTypes,
		["Talent 3"] = self.talentTypes,
		["Disability 1"] = self.disabilityTypes,
		["Disability 2"] = self.disabilityTypes,
		["Disability 3"] = self.disabilityTypes,
		["Height"] = self.heightList,
		["Facial Hair"] = self.facialHairList
	}
	self.selectedAttrIndex = nil
	self.selectedPlayer = nil
	self.selectedPlayerLoaded = ""
	self.dataStringAttrs = ""
	self.dataStringCustom1 = ""
	self.dataStringCustom2 = ""
	self.chanTMM = "__TMM__" 
	self.Comm = nil
	self.unit = nil
	self.DEBUGMODE = false
	self.loadedProfiles = {}
	local i = 0
	self.defaultString = ""
	while i ~= #self.DataStructure do
		self.defaultString = self.defaultString .. "A"
		i = i+1
	end
    return o
end

function TellMeMore:Print(strToPrint)
	if self.DEBUGMODE then
	 	Print(strToPrint)
	end
end

function TellMeMore:Init()
	local bHasConfigureFunction = false
	local strConfigureButtonText = ""
	local tDependencies = {
		-- "UnitOrPackageName",
	}
    Apollo.RegisterAddon(self, bHasConfigureFunction, strConfigureButtonText, tDependencies)
end
 

-----------------------------------------------------------------------------------------------
-- TellMeMore OnLoad
-----------------------------------------------------------------------------------------------
function TellMeMore:OnLoad()
    -- load our form file
	self.xmlDoc = XmlDoc.CreateFromFile("TellMeMore.xml")
	self.xmlDoc:RegisterCallback("OnDocLoaded", self)
	
end

-----------------------------------------------------------------------------------------------
-- TellMeMore OnDocLoaded
-----------------------------------------------------------------------------------------------
function TellMeMore:OnDocLoaded()

	if self.xmlDoc ~= nil and self.xmlDoc:IsLoaded() then
	    self.wndMain = Apollo.LoadForm(self.xmlDoc, "TellMeMoreForm", nil, self)
		self.wndInspect = Apollo.LoadForm(self.xmlDoc, "InspectForm", nil, self)
		if self.wndMain == nil then
			Apollo.AddAddonErrorText(self, "Could not load the main window for some reason.")
			return
		end
		
	    self.wndMain:Show(false, true)
		self.wndInspect:Show(false, true)
		self.wndInspect:FindChild("GlowBox"):Show(false)
		self.wndInspect:FindChild("GlowBox1"):Show(false)
		self.wndInspect:FindChild("GlowBox2"):Show(false)
		self.wndMain:FindChild("CustomBox1"):SetMaxTextLength(75)
		self.wndMain:FindChild("CustomBox2"):SetMaxTextLength(75)
		-- if the xmlDoc is no longer needed, you should set it to nil
		-- self.xmlDoc = nil
		
		-- Register handlers for events, slash commands and timer, etc.
		-- e.g. Apollo.RegisterEventHandler("KeyDown", "OnKeyDown", self)
		Apollo.RegisterEventHandler("InterfaceMenuListHasLoaded", "OnInterfaceMenuListHasLoaded", self)
		Apollo.RegisterEventHandler("GenericEvent_OpenTMM", "menuHandler", self)
		Apollo.RegisterSlashCommand("tmm", "OnTellMeMoreOn", self)

		self.timer = ApolloTimer.Create(1.0, true, "OnTimer", self)
		self.selGrid = self.wndMain:FindChild("SelectionGrid")
		self.attrGrid = self.wndMain:FindChild("AttributeGrid")
		self.loadedAttrGrid = self.wndInspect:FindChild("LoadedAttrGrid")
	--	self.loadedAttrGrid:Enable(false)
		self.inspectName = self.wndInspect:FindChild("NameField")
		self.inspectCustom1 = self.wndInspect:FindChild("CustomText1")
		self.inspectCustom2 = self.wndInspect:FindChild("CustomText2")
		-- Do additional Addon initialization here
	
		self.attrGrid:DeleteAll()
		local tRow
		for k, v in ipairs(self.DataStructure) do
			tRow = self.attrGrid:AddRow("")
			self.attrGrid:SetCellText(tRow, 1, v)
			if self.DataArrays[v][self.DataToSend[v]] == nil then
				self.attrGrid:SetCellText(tRow, 2, "N/A")
				self.DataToSend[v] = 1
			else
				self.attrGrid:SetCellText(tRow, 2, self.DataArrays[v][self.DataToSend[v]])
			end
		end
		self.wndMain:FindChild("CustomBox1"):SetText(self.dataStringCustom1)
		self.wndMain:FindChild("CustomBox2"):SetText(self.dataStringCustom2)
	end
	if self.hasVersionChanged then
		Print("Tell Me More Version has changed, please redo your profile")
	end
	self.dataStringAttrs = self:BuildDataString()
	self.startupTimer = ApolloTimer.Create(5, false, "SetupComms", self)
	self.sendQueue = {}
	self.currentEntries = {}
	self.heartbeatEntries = {}
end


function TellMeMore:OnInterfaceMenuListHasLoaded()
	Event_FireGenericEvent("InterfaceMenuList_NewAddOn", "Tell Me More", {"GenericEvent_OpenTMM", "", "CRB_HUDAlerts:sprAlert_CallBase"})
end
-----------------------------------------------------------------------------------------------
-- TellMeMore Functions
-----------------------------------------------------------------------------------------------
-- Define general functions here



function TellMeMore:OnHeartbeatCompare()
   for k, v in pairs(self.currentEntries) do
     if (k ~= self.playerName and self.heartbeatEntries[k] == nil) then 
			self.currentEntries[k] = nil
			self.loadedProfiles[k] = nil
	 end
   end
   self.heartbeatEntries = {}
end

function TellMeMore:OnHeartbeatHello()
	if self.dataStringAttrs ~= self.defaultString or self.dataStringCustom1 ~= "" or self.dataStringCustom2 ~= "" then
		self:SendMessage(self.faction)
	end
end

-- on SlashCommand "/tmm"
function TellMeMore:OnTellMeMoreOn(strCommand, strArgs)
	self.wndMain:Close()
	self.wndInspect:Close()
	self.DataReceived = {} 
	if strArgs == "me" then
		self.wndMain:Invoke() -- show the window
	elseif strArgs == "" then
		self.wndInspect:Invoke()
		self:RefreshList()
	end
end

function TellMeMore:BuildListFromEncoded(encString)
	if encString == nil then
		return nil
	end
	local toReturn = {}
	for i, value in ipairs(self.DataStructure) do
		local decoded = self:Decode(encString:sub(i,i))
		if decoded > #self.DataArrays[value] then
			toReturn[i] = {value, "1"}		-- Make backwards compatible. If new entries are added, old versions will not have, so just do not render it.
		else
			toReturn[i] = {value, self:Decode(encString:sub(i,i))}
		end
	end
	return toReturn
end


-- on timer
function TellMeMore:OnTimer()
	-- Do your timer-related stuff here.
end

function TellMeMore:OnSave(eLevel)
    if eLevel ~= GameLib.CodeEnumAddonSaveLevel.Character then
        return nil
    end	
	return {dataToSend = self.DataToSend, version = self.version, custom1 = self.dataStringCustom1, custom2 = self.dataStringCustom2}
end
function TellMeMore:OnRestore(eLevel, tData)
	if GameLib.CodeEnumAddonSaveLevel.Character then
		if self.version == tData.version then
    		self.DataToSend = tData.dataToSend
			self.dataStringCustom1 = tData.custom1
			self.dataStringCustom2 = tData.custom2
		else
			self.hasVersionChanged = true
		end
	end
end

function TellMeMore:SetupComms()
	self.unit = GameLib.GetPlayerUnit()
	if self.unit ~=nil then
		self.playerName = self.unit:GetName()
		self.faction = self.unit:GetFaction()
		self.loadedProfiles[self.playerName] = {}
		self.loadedProfiles[self.playerName][4] = self.faction
		self.loadedProfiles[self.playerName][2] = self.dataStringCustom1
		self.loadedProfiles[self.playerName][3] = self.dataStringCustom2
		self.loadedProfiles[self.playerName][1] = self.dataStringAttrs
		if self.faction == 166 then
			self.faction = "D"
		elseif self.faction == 167 then
			self.faction = "E"
		else
			self.faction = "?"
		end
		self.chanTMM = self.chanTMM
		self.Comm = ICCommLib.JoinChannel(self.chanTMM, ICCommLib.CodeEnumICCommChannelType.Global)
		self.Comm:SetJoinResultFunction("OnJoinResult", self)
		self.Comm:SetReceivedMessageFunction("OnMessageReceived", self)
		self.Comm:SetSendMessageResultFunction("OnMessageSent", self)
		self.Comm:SetThrottledFunction("OnMessageThrottled", self)
		self.startupTimer:Stop()
		self.heartbeatHello = ApolloTimer.Create(20, true, "OnHeartbeatHello", self)
		self.heartbeatCompare = ApolloTimer.Create(40, true, "OnHeartbeatCompare", self)
		self:SendMessage("#")
		if (self.dataStringAttrs ~= self.defaultString and #self.dataStringAttrs == #self.defaultString) or self.dataStringCustom1 ~= "" or self.dataStringCustom2 ~= "" then
			self:SendFullInfo()
		end
	end
end

function TellMeMore:SendMessage(message)
	if (self.unit ~= nil) and self.Comm:IsReady() and message ~= nil then
		self.Comm:SendMessage(message)
		self:Print("Message Sent")
		return true
	else
		self.startupTimer = ApolloTimer.Create(5, false, "SetupComms", self)
	end
	self:Print("Failed to send for some reason")
	return false
end

function TellMeMore:SendFullInfo()
	if self.dataStringAttrs ~= self.defaultString or self.dataStringCustom1 ~= "" or self.dataStringCustom2 ~= "" then
		self:Print("Preparing to send full info")
		self.sendTimer = ApolloTimer.Create(2, true, "sendOnTimer", self)
		self.sendQueue = self:BuildTransmitData()
	end
end

function TellMeMore:sendOnTimer()
	if self.sendQueue[1] ~= "" then
		self:SendMessage(self.sendQueue[1])
	end
	table.remove(self.sendQueue,1)
	if #self.sendQueue == 0 then
		self.sendTimer:Stop()
	end
end

function TellMeMore:OnMessageSent(channel, eResult, idMessage)
end

function TellMeMore:OnMessageThrottled(channel, eResult, idMessage)
end

function TellMeMore:OnJoinResult(channel, eResult)
	local bJoin = eResult == ICCommLib.CodeEnumICCommJoinResult.Join
	if bJoin then
		self:Print(string.format('TMM: Joined ICComm Channel "%s"', channel:GetName()))
		if channel:IsReady() then
			self:Print('TMM: Channel is ready to transmit')
			self:SendFullInfo()
		else
			self:Print('TMM: Channel is not ready to transmit')
		end
	else
		self:Print('TMM: Failed to join')	
	end
end


function TellMeMore:OnMessageReceived(channel, strMessage, strSender)
		self:Print("Received message")
		if self.heartbeatEntries[strSender] == nil then
			self.heartbeatEntries[strSender] = "?"
		end
		if strMessage == "~" then
			self:SendFullInfo()
			return
		elseif strMessage == "#" then
			self:OnHeartbeatHello()
			return
		end
		
		if self.currentEntries[strSender] == nil then
			self.currentEntries[strSender] = {"?", false}
			self.wndInspect:FindChild("GlowBox2"):Show(true)
		end
		if self.loadedProfiles[strSender] == nil then
			self:Print("Setting to nil~")
			self.loadedProfiles[strSender] = {}
		end
		
		if strMessage == "D" or strMessage == "E" then
			self.heartbeatEntries[strSender] = strMessage
			self.currentEntries[strSender][1] = strMessage
		elseif strMessage:sub(1,1) == "[" then
			self.loadedProfiles[strSender][2] = strMessage:sub(2, #strMessage)
		elseif strMessage:sub(1,1) == "]" then
			self.loadedProfiles[strSender][3] = strMessage:sub(2, #strMessage)
		elseif strMessage:sub(1,1) == "@" then
			self.loadedProfiles[strSender][4] = strMessage:sub(2, #strMessage)
			self.currentEntries[strSender][1] = strMessage:sub(2, #strMessage)
			self.heartbeatEntries[strSender] = strMessage
		elseif #strMessage <= #self.DataStructure then
			self.loadedProfiles[strSender][1] = strMessage
			self.wndInspect:FindChild("GlowBox2"):Show(true)
		else
			self:Print("No match")
		end
		
		if self.currentEntries[strSender][2] ~= true and self.loadedProfiles[strSender][1] ~= nil and self.loadedProfiles[strSender][2] ~= nil and self.loadedProfiles[strSender][3] ~= nil and self.loadedProfiles[strSender][4] ~= nil then
			self.currentEntries[strSender][2] = true
			self.wndInspect:FindChild("GlowBox2"):Show(true)
			self:Print("All good!")
		end
		self:Print(string.format("Received: %s %s", strMessage, strSender))
end

function TellMeMore:DrawWindow(drawList)
	self.selGrid:DeleteAll()
	local tRow
	for i, dataType in ipairs(drawList) do
		if (i-1)%2==0 then 
			tRow = self.selGrid:AddRow("")
		end
		self.selGrid:SetCellText(tRow, (i-1)%2+1, dataType)
	end
end
-----------------------------------------------------------------------------------------------
-- TellMeMoreForm Functions
-----------------------------------------------------------------------------------------------
-- when the OK button is clicked
function TellMeMore:OnOK()
	self.DataToSend[self.activeTrait] = self.selectedGridElement
	self.wndMain:FindChild(self.activeTrait .. "Button"):SetText(self.selectedText)
	self.selGrid:DeleteAll()
	--self.wndMain:Close() -- hide the window
end

-- when the Cancel button is clicked
function TellMeMore:OnCancel()
	self.wndMain:Close()
end

function TellMeMore:OnInspectCancel()
	self.wndInspect:Close()
end

function TellMeMore:onGridSelChange(wndHandler, wndControl, iRow, iCol)
	numIndex = ((iRow-1)*2+iCol)
	self.selectedGridElement = (iRow-1)*2+iCol
	self.selectedText = wndControl:GetCellText(iRow, iCol)
	self.DataToSend[self.activeTrait] = self.selectedGridElement
	self.attrGrid:SetCellText(self.selectedAttrIndex, 2, self.selectedText)
	self.selGrid:DeleteAll()
end

function TellMeMore:Encode(numToEncode)
	if numToEncode == nil then
		return '-'
	end
	local b64='ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/'
	return b64:sub(numToEncode,numToEncode)
end

function TellMeMore:Decode(charToDecode) 
	if charToDecode == '-' then
		return nil
	end
	local b64='ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/'
	return string.find(b64, charToDecode,1)
end

function TellMeMore:BuildDataString()
	local BuiltString = ""
	for i, value in ipairs(self.DataStructure) do
		if self.DataToSend[value] == nil or #self.DataArrays[value] + 1 < self.DataToSend[value] then
			BuiltString = BuiltString .. "A"
			self.DataToSend[value] = 1
		else
			BuiltString = BuiltString .. self:Encode(self.DataToSend[value])
		end
	end
	return BuiltString
end

function TellMeMore:BuildTransmitData()
	local transmitArray = {}
	transmitArray[4] = self.dataStringAttrs
	transmitArray[2] = "[" .. self.dataStringCustom1
	transmitArray[3] = "]" .. self.dataStringCustom2
	transmitArray[1] = "@" .. self.faction
	self.loadedProfiles[self.playerName] = {}
	self.loadedProfiles[self.playerName][4] = self.faction
	self.loadedProfiles[self.playerName][2] = self.dataStringCustom1
	self.loadedProfiles[self.playerName][3] = self.dataStringCustom2
	self.loadedProfiles[self.playerName][1] = self.dataStringAttrs
	return transmitArray
end

function TellMeMore:OnUnitCreated(unit)
	if not unit:IsACharacter() then
		return
	end
	if self.loadedProfiles[unit:GetName()] ~= nil then
		self.nearbyPlayers.insert(unit)
	end
end

function TellMeMore:onAttributeGridSelChange(wndHandler, wndControl, iRow, iCol)
	self.activeTrait = wndControl:GetCellText(iRow,1)
	self.selectedAttrIndex = iRow
	self:DrawWindow(self.DataArrays[self.activeTrait])

end

function TellMeMore:SaveAndExit( wndHandler, wndControl, eMouseButton )
	self.dataStringCustom1 = self.wndMain:FindChild("CustomBox1"):GetText()
	self.dataStringCustom2 = self.wndMain:FindChild("CustomBox2"):GetText()
	if self.dataStringCustom1 == nil then
		self.dataStringCustom1 = ""
	end
	if self.dataStringCustom2 == nil then
		self.dataStringCustom2 = ""
	end
	self.wndMain:FindChild("SaveButton"):Enable(false)
	self.delayEditing = ApolloTimer.Create(10, false, "OnReenableEdit", self)
	self.dataStringAttrs = self:BuildDataString()
	self:SendFullInfo()
	self.wndMain:Close()
	self.wndInspect:Invoke()
end

function TellMeMore:OnReenableEdit()
	self.wndMain:FindChild("SaveButton"):Enable(true)
end

function TellMeMore:onPopulationListChange(wndHandler, wndControl, iRow, iCol)
	self.selectedPlayer = wndControl:GetCellText(iRow, 1)
	self.selectedPlayerLoaded = wndControl:GetCellText(iRow, 3)
	self:renderInspectAttr(self.selectedPlayer, self.selectedPlayerLoaded)
end

function TellMeMore:renderInspectAttr(playerName, isLoaded)
		self.wndInspect:FindChild("GlowBox"):Show(false)
		self.wndInspect:FindChild("RequestInfoButton"):Enable(false)
		if isLoaded == "Yes" then
			self.inspectName:SetText(playerName)
			self.wndInspect:FindChild("RequestInfoButton"):Enable(false)
			local attrStrList = self:BuildListFromEncoded(self.loadedProfiles[playerName][1])
			if attrStrList == nil then
			  return
			end
			local customText1 = self.loadedProfiles[2]
			local customText2 = self.loadedProfiles[3]
			self.loadedAttrGrid:DeleteAll()
			local tRow
			for i, dataType in pairs(attrStrList) do
				if dataType[2] ~= 1 and dataType[1] ~= nil and self.DataArrays[dataType[1]][dataType[2]] ~= nil then
					tRow = self.loadedAttrGrid:AddRow("")
					self.loadedAttrGrid:SetCellText(tRow, 1, dataType[1])
					self.loadedAttrGrid:SetCellText(tRow, 2, self.DataArrays[dataType[1]][dataType[2]])
				end	
			end
			self.loadedAttrGrid:ArrangeChildrenVert()
			self.inspectCustom1:SetText(self.loadedProfiles[playerName][2])
			self.inspectCustom2:SetText(self.loadedProfiles[playerName][3])
		else
			if self.selectedPlayer ~= nil then
				self.inspectName:SetText(playerName)
				self.loadedAttrGrid:DeleteAll()
				self.inspectCustom1:SetText("Player not loaded")
				self.inspectCustom2:SetText("Request Info for more information on this player")
				self.wndInspect:FindChild("GlowBox"):Show(true)
				self.wndInspect:FindChild("GlowBox1"):Show(false)
				editButton = self.wndInspect:FindChild("RequestInfoButton"):Enable(true)
			end
		end
end

function TellMeMore:backToList( wndHandler, wndControl, eMouseButton )
		self.wndMain:Close()
		self.wndInspect:Invoke()
end

function TellMeMore:menuHandler()
	self.wndInspect:Show(not self.wndInspect:IsShown())
	self.wndMain:Close()
end

---------------------------------------------------------------------------------------------------
-- InspectForm Functions
---------------------------------------------------------------------------------------------------

function TellMeMore:RefreshList()
	self.selectedPlayer = nil
	if self.wndInspect:FindChild("NameField"):GetText() ~= "" and self.loadedProfiles[self.wndInspect:FindChild("NameField"):GetText()] ~= nil then
		self:renderInspectAttr(self.wndInspect:FindChild("NameField"):GetText(), self.selectedPlayerLoaded)
	end
	self.wndInspect:FindChild("GlowBox2"):Show(false)
	local tRow
	local allEntries = self.wndInspect:FindChild("AllEntries")
	allEntries:DeleteAll()
	if self.playerName ~= nil then
		tRow = allEntries:AddRow("")
		allEntries:SetCellText(tRow, 1, self.playerName)
		allEntries:SetCellText(tRow, 2, "You")
		allEntries:SetCellText(tRow, 3, "Yes")
	end
	for i, data in pairs(self.currentEntries) do
		tRow = allEntries:AddRow("")
		allEntries:SetCellText(tRow, 1, i)
		allEntries:SetCellText(tRow, 2, data[1])
		if data[2] == true then
			allEntries:SetCellText(tRow, 3, "Yes")
		else
			allEntries:SetCellText(tRow, 3, "No")
		end
		
	end
end

function TellMeMore:OnReenableRequest()
	self:renderInspectAttr(self.selectedPlayer, "Yes")
	self:RefreshList()
	--self.wndInspect:FindChild("RequestInfoButton"):Enable(true)
	self.wndInspect:FindChild("AllEntries"):Enable(true)
	self.wndInspect:FindChild("GlowBox1"):Show(false)
 	self.wndInspect:FindChild("RefreshButton"):Enable(true)
	self.delayButtonPressing:Stop()
end

function TellMeMore:RequestInfo( wndHandler, wndControl, eMouseButton )
	if self.selectedPlayer ~= nil then
		self.Comm:SendPrivateMessage(self.selectedPlayer,"~")
		self.wndInspect:FindChild("RequestInfoButton"):Enable(false)
		self.wndInspect:FindChild("GlowBox"):Show(false)
		self.wndInspect:FindChild("GlowBox1"):Show(true)
		self.wndInspect:FindChild("AllEntries"):Enable(false)
		self.wndInspect:FindChild("RefreshButton"):Enable(false)
		self.delayButtonPressing = ApolloTimer.Create(10, false, "OnReenableRequest", self)
	end
end

function TellMeMore:drawEditor( wndHandler, wndControl, eMouseButton )
		self.wndInspect:Close()
		self.wndMain:Invoke() -- show the window
end

-----------------------------------------------------------------------------------------------
-- TellMeMore Instance
-----------------------------------------------------------------------------------------------
local TellMeMoreInst = TellMeMore:new()
TellMeMoreInst:Init()
